<template>
  <div :class="classObj" class="app-wrapper">
    <hamburger :is-active="sidebar.opened" class="hamburger-container" @toggleClick="toggleSideBar" />
    <div
      v-if="device === 'mobile' && sidebar.opened"
      class="drawer-bg"
      @click="handleClickOutside"
    />
    <sidebar class="sidebar-container" />
    <el-scrollbar ref="scroll" style="height: 100%">
      <div class="main-container">
        <div :class="{ 'fixed-header': fixedHeader }">
          <navbar />
        </div>
        <app-main />
        <foot-mark />
      </div>
    </el-scrollbar>
  </div>
</template>

<script>
import { Navbar, Sidebar, AppMain, FootMark } from './components'
import Hamburger from '@/components/Hamburger'
// import ResizeMixin from './mixin/ResizeHandler'

export default {
  name: 'Layout',
  components: {
    Navbar,
    Sidebar,
    AppMain,
    FootMark,
    Hamburger
  },
  // mixins: [ResizeMixin],
  computed: {
    sidebar() {
      return this.$store.state.app.sidebar
    },
    device() {
      return this.$store.state.app.device
    },
    fixedHeader() {
      return this.$store.state.settings.fixedHeader
    },
    classObj() {
      return {
        hideSidebar: !this.sidebar.opened,
        openSidebar: this.sidebar.opened,
        withoutAnimation: this.sidebar.withoutAnimation,
        mobile: this.device === 'mobile'
      }
    }
  },
  watch: {
    $route: {
      handler(val) {
        this.$nextTick(() => {
          this.$refs.scroll.wrap.scrollTop = 0
          this.$store.commit('scrollStore/SET_SCROLL_REFS', this.$refs.scroll)
        })
      },
      immediate: true
    }
  },
  methods: {
    toggleSideBar() {
      this.$store.dispatch('app/toggleSideBar')
    },
    handleClickOutside() {
      this.$store.dispatch('app/closeSideBar', { withoutAnimation: false })
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~@/styles/mixin.scss";
@import "~@/styles/variables.scss";

.app-wrapper {
  @include clearfix;
  position: relative;
  height: 100%;
  width: 100%;
  &.mobile.openSidebar {
    position: fixed;
    top: 0;
  }
  .hamburger-container {
    position: absolute;
    left: 0;
    bottom: 0;
    line-height: 46px;
    height: 60px;
    cursor: pointer;
    transition: background .3s;
    -webkit-tap-highlight-color:transparent;
    z-index: 9;

    &:hover {
      background: rgba(0, 0, 0, .025)
    }
  }
}
.drawer-bg {
  background: #000;
  opacity: 0.3;
  width: 100%;
  top: 0;
  height: 100%;
  position: absolute;
  z-index: 999;
}

.fixed-header {
  position: fixed;
  background-color: #f6f9fc;
  top: 0px;
  right: 20px;
  z-index: 9;
  width: calc(100% - 260px);
  // width: calc(100% - #{$sideBarWidth} -20px);
  transition: width 0.28s;
}

.hideSidebar .fixed-header {
  width: 100%;
  // width: calc(100% - 54px);
}

.mobile .fixed-header {
  width: 100%;
}
</style>
